using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;
using System.Net;
using System.IO;
using System.Threading;
using System.Diagnostics;

namespace YProcessMgr
{
	class YStreamConnector
	{
		TcpClient m_tClient;
		StreamWriter m_sw;
		StreamReader m_sr;
		NetworkStream m_ns;
		public YStreamConnector( TcpClient tClient )
		{
			m_tClient = tClient;
			NetworkStream ns = m_tClient.GetStream();
			m_ns = ns;
			m_sw = new StreamWriter( ns );
			m_sr = new StreamReader( ns );
		}
		
		private void OutputEventHandler( object sendingProcess, DataReceivedEventArgs outLine )
		{
			if( m_sr == null ) return;
			if( !String.IsNullOrEmpty( outLine.Data ) ) {
				this.m_sw.WriteLine( "" + outLine.Data );
				this.m_sw.Flush();
			}
		}
		

		private void ReadOutput( object sro )
		{
			StreamReader sr = (StreamReader)sro;
			char ch;
			int i;
			try {
				while( (i = sr.Read()) >= 0 ) {
					ch = (char)i;
					this.m_sw.Write( ch );
					this.m_sw.Flush();
				}
			} catch {
				return;
			}
		}
		public void Work()
		{
			StreamReader sr = m_sr;
			StreamWriter sw = m_sw;
			string str = sr.ReadLine();
			if( str.Contains( "start" ) ) {
				sw.WriteLine( "filename and argument, please" );
				sw.Flush();
				string strArgs = sr.ReadLine();
				if( strArgs == null ) return;
				string[] arrArgs = strArgs.Split( new char[] { ' ' } );
				if( arrArgs.Length < 1 ) return;
				Process p = new Process();
				p.StartInfo.FileName = arrArgs[0];
				p.StartInfo.UseShellExecute = false;
				p.StartInfo.RedirectStandardOutput = true;
				p.StartInfo.RedirectStandardInput = true;			
				//p.OutputDataReceived += new DataReceivedEventHandler( this.OutputEventHandler );
				p.StartInfo.Arguments = "";
				for( int i = 1; i < arrArgs.Length; i++ ) {
					p.StartInfo.Arguments += arrArgs[i] + " ";
				}
				Thread th = new Thread( new ParameterizedThreadStart( this.ReadOutput ) );
				
				p.Start();
				th.Start( p.StandardOutput );
				//p.BeginOutputReadLine();
				try {
					while( ( !p.HasExited ) && ( ( str = sr.ReadLine() ) != null ) ) {
						if( p.HasExited ) break;
						p.StandardInput.WriteLine( str );
						p.StandardInput.Flush();
					}
				} catch {
				}
				p.WaitForExit();
				m_sw.Close();
				m_sw = null;
				m_sr.Close();
				m_sr = null;
				m_tClient.Close();
				p.Close();
			}
		}
	}
	class YProcListener
	{
		int m_nPort;
		public YProcListener( int nPort )
		{
			m_nPort = nPort;
		}
		public void ProcessConnection( object tClientObj )
		{
			TcpClient tClient = (TcpClient)tClientObj;
			YStreamConnector connector = new YStreamConnector( tClient );
			connector.Work();
		}
		public void Listen()
		{
			TcpListener tListener = new TcpListener( IPAddress.Any, m_nPort );
			tListener.Start();
			Console.WriteLine( "Listening on port {0}", m_nPort );
			while( true ) {
				TcpClient tClient = tListener.AcceptTcpClient();
				Thread th = new Thread( new ParameterizedThreadStart( ProcessConnection ) );
				th.Start( tClient );
			}
		}
	}
	class Program
	{
		static void Main( string[] args )
		{
			int nPort;
			nPort = 11022;
			if( args.Length >= 1 ) {
				nPort = Int32.Parse( args[0] );
			}
			YProcListener yProcListener = new YProcListener( nPort );
			yProcListener.Listen();
		}
	}
}
