using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using Antlr.Runtime;
using System.IO;
namespace Yaccai
{
	class YaccaiMain
	{
		private static ArrayList m_arrAvailableHost;
		public static YaccaiParser GetParser( string strFileName )
		{
			YaccaiLexer lex = new YaccaiLexer( new Antlr.Runtime.ANTLRFileStream( strFileName ) );
			CommonTokenStream tks = new CommonTokenStream( lex );
			YaccaiParser p = new YaccaiParser( tks );
			p.StrInputFileName = strFileName;
			return p;
		}

		static string ParseCmdLine( string[] argInput, Hashtable hOptions, ArrayList argv )
		{
			if( argInput.Length < 1 ) {
				Console.WriteLine( "Missing input file" );
				Environment.Exit( 1 );
			}
			string strRet = null;
			hOptions.Clear();
			int i = 0;
			while( argInput[i].StartsWith( "-" ) ) {
				string strOption = argInput[i];
				i++;
				if( !hOptions.ContainsKey( strOption ) ) {
					hOptions.Add( strOption, null );
				} else hOptions[strOption] = null;
				if( i >= argInput.Length - 1 ) {
					break;
				}
				string strOptionVal = argInput[i];
				if( !strOptionVal.StartsWith( "-" ) ) {
					hOptions[strOption] = strOptionVal;
					i++;
				}
			}
			if( !argInput[i].StartsWith( "-" ) ) {
				strRet = argInput[i];
				i++;
			}
			while( i < argInput.Length ) {
				argv.Add( argInput[i] );
				i++;
			}
			if( strRet == null ) {
				Console.WriteLine( "Missing input file" );
				Environment.Exit( 1 );
			}
			return strRet;
		}
		static void Main( string[] args )
		{
			/*
			YaccaiParser p = GetParser( "test2.c" );
			LinkedList<Stmt> stmList = p.translation_unit();
			string strFileContents = PrintUtil.PrettyPrint( stmList, 0 );
			Console.WriteLine( strFileContents );
			if( p.IsSuccessParse() ) {
				Console.WriteLine( "Successfully parsed file {0} ", p.StrInputFileName );
				YEvaluator ye = new YEvaluator( args );
				ye.ExecuteFileInput( "tes2.c" );
				//ye.EvalFileInput( stmList, new YEnv() );
			} else {
				Console.WriteLine( "Parse failed!" );
			}
			*/
			/*
			YEvaluator ye = new YEvaluator( args );
			ye.ExecuteFileInput( "testplan.c" );
			*/
			Hashtable hOptions = new Hashtable();
			ArrayList argv = new ArrayList();
			string strFileName = ParseCmdLine( args, hOptions, argv );
			if( strFileName != null ) {
				YEvaluator yEval = new YEvaluator( argv );
				string strPortMgrAddr;
				int nPortMgrPort;
				if( hOptions.ContainsKey( "-pma" ) ) {
					strPortMgrAddr = (string)hOptions["-pma"];
				} else strPortMgrAddr = "localhost";
				if( hOptions.ContainsKey( "-pmp" ) ) {
					nPortMgrPort = Int32.Parse( (string)hOptions["-pmp"] );
				} else nPortMgrPort = 31572;
				yEval.SetPortMgrAddr( strPortMgrAddr, nPortMgrPort );
				int nRank = -1;
				if( hOptions.ContainsKey( "-rank" ) ) {
					nRank = Int32.Parse( (string)hOptions["-rank"] );
				}
				if( hOptions.ContainsKey( "-yiop" ) ) {
					yEval.m_nIOConnectorPort = Int32.Parse( (string)hOptions["-yiop"] );
				}
				/*
				string strDebugRank = "";
				if( !strDebugRank.Equals( "" ) ) nRank = Int32.Parse( strDebugRank );
				 */
				yEval.SetMyRank( nRank );
				if( hOptions.ContainsKey( "-hostfile" ) ) {
					m_arrAvailableHost = new ArrayList();
					FileLookup fLook = new FileLookup();
					string strHostFile = fLook.LookupFile( (string)hOptions["-hostfile"] );
					FileStream fs = File.Open( strHostFile, FileMode.Open );
					StreamReader sr = new StreamReader( fs );
					string strHostname = null;
					while( (strHostname = sr.ReadLine()) != null ) {
						m_arrAvailableHost.Add( strHostname );
					}
				}
				if( hOptions.ContainsKey( "-m" ) ) {
					yEval.ExecuteAgent( strFileName, (string)hOptions["-m"], argv );
				} else {
					yEval.ExecuteFileInput( strFileName );
				}
			}
		}
	}
}
