using System;
using System.Collections;
using Antlr.Runtime;
using System.Net.Sockets;
using System.Net;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;

namespace Yaccai
{
	class YNativeFuncs
	{
		public YNativeFuncs()
		{
		}
		public static void Write( YaccaiVal args )
		{

		}
		public static string StringOperatorPlus( string str1, object str2 )
		{
			return str1 + str2.ToString();
		}
		public static YaccaiVal ObjectObject_0( object thisVal )
		{
			return NativeObjects.YObject();
		}
		public static YaccaiVal ArrayArray_0( YObject thisVal )
		{
			YObject yObj = thisVal;
			yObj.m_instanceVars.Add( "2contents", new ArrayList() );
			yObj.m_instanceVars.Add( "Length", new YaccaiVal( YaccaiType.INT, 0 ) );
			return new YaccaiVal( YaccaiType.VOID, null ) ;
		}
		public static YaccaiVal ArrayArray_1( YObject thisVal, int n )
		{
			YObject yObj = thisVal;
			ArrayList lst = new ArrayList( n );
			yObj.m_instanceVars.Add( "2contents", lst );
			yObj.m_instanceVars.Add( "Length", new YaccaiVal( YaccaiType.INT, n ) );

			return new YaccaiVal( YaccaiType.VOID, null );
		}
		public static YaccaiVal CreateYArrayFromArrList( ArrayList arrList )
		{
			YClass yArrayClass = (YClass)NativeObjects.YArrayClass().m_contents;
			Hashtable hInstanceVars = new Hashtable();
			hInstanceVars.Add( "2contents", arrList );
			hInstanceVars.Add( "Length", new YaccaiVal( YaccaiType.INT, arrList.Count ) );
			ArrayList parentObjs = new ArrayList();
			parentObjs.Add( NativeObjects.YObject() );
			YObject yObj = new YObject( yArrayClass, hInstanceVars, parentObjs );
			return new YaccaiVal( YaccaiType.OBJECT, yObj );
		}
		public static YaccaiVal ArrayOperatorSubscript( YObject thisVal, int nIndex )
		{
			ArrayList lst = (ArrayList)thisVal.m_instanceVars["2contents"];
			if( lst == null ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Null pointer exception" );
			}
			if( nIndex >= lst.Count ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Index out of range: length = " + lst.Count + ", index = " + nIndex );
			}
			YaccaiVal v = (YaccaiVal)lst[nIndex];
			return new YaccaiVal( v.m_type, v.m_contents );
		}
		public static YaccaiVal ArrayAdd( YObject thisVal, object yVal )
		{
			YaccaiVal v = YaccaiVal.UnMarshall( yVal );
			ArrayList lst = (ArrayList)thisVal.m_instanceVars["2contents"];
			lst.Add( v );
			( (YaccaiVal)thisVal.m_instanceVars["Length"] ).m_contents = lst.Count;
			return new YaccaiVal( YaccaiType.VOID, null );
		}
		public static YaccaiVal ArrayOperatorSubscriptLvalue( YObject thisVal, int nIndex )
		{
			ArrayList lst = (ArrayList)thisVal.m_instanceVars["2contents"];
			return (YaccaiVal)lst[nIndex];
		}
		public static YaccaiVal StringToInt( string strVal )
		{
			int intVal = Int32.Parse( strVal );
			return new YaccaiVal( YaccaiType.INT, intVal );
		}

		public static YaccaiVal StringToDouble( string strVal )
		{
			double doubleVal = Double.Parse( strVal );
			return new YaccaiVal( YaccaiType.DOUBLE, doubleVal );
		}

	}
	partial class YEvaluator
	{
		public YaccaiVal NtPrintStackTrace( ArrayList args, YEnv env )
		{
			PrintStackTrace( this.m_callStack );
			return new YaccaiVal( YaccaiType.VOID );
		}
		public YaccaiVal NtEnvironment_Exit( ArrayList args, YEnv env )
		{
			if( args.Count != 2 ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Invalid argument number" );
			}
			// TODO: close all network connections, openning files, ... here
			YaccaiVal v1 = (YaccaiVal)args[1];
			if( v1.m_type != YaccaiType.INT ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Invalid argument type for Exit" );
			}
			int nCode = (int)v1.m_contents;
			Environment.Exit( nCode );
			return new YaccaiVal( YaccaiType.VOID, null );
		}
		public YaccaiVal NtSleep( ArrayList args, YEnv env )
		{
			if( args.Count < 2 ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Invalid argument number for Sleep" );
			}
			int mSec = (int)( (YaccaiVal)args[1] ).m_contents;
			System.Threading.Thread.Sleep( mSec );
			return new YaccaiVal( YaccaiType.VOID, null );
		}

		public YaccaiVal NtObjectOperatorEqEq( ArrayList args, YEnv env )
		{
			if( args.Count != 2 ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Invalid argument number for operator==" );
			}
			YaccaiVal v1 = (YaccaiVal)args[0];
			YaccaiVal v2 = (YaccaiVal)args[1];
			if( v1.m_type != v2.m_type ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Could not compare 2 different types" );
			}
			if( v1.m_type == YaccaiType.OBJECT ) {
				if( v2.m_type == YaccaiType.OBJECT ) {
					if( v1.m_contents == v2.m_contents ) {
						return new YaccaiVal( YaccaiType.INT, 1 );
					}
				}
			}
			return new YaccaiVal( YaccaiType.INT, 0 );
		}
		public YaccaiVal NtObjectOperatorDiff( ArrayList args, YEnv env )
		{
			if( args.Count != 2 ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Invalid argument number for operator !=" );
			}
			YaccaiVal v1 = (YaccaiVal)args[0];
			YaccaiVal v2 = (YaccaiVal)args[1];
			if( v1.m_type != v2.m_type ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Could not compare 2 different types" );
			}
			if( v1.m_type == YaccaiType.OBJECT ) {
				if( v2.m_type == YaccaiType.OBJECT ) {
					if( v1.m_contents != v2.m_contents ) {
						return new YaccaiVal( YaccaiType.INT, 1 );
					}
				}
			}
			return new YaccaiVal( YaccaiType.INT, 0 );

		}

		public YaccaiVal NtInstanceOf( ArrayList args, YEnv env )
		{
			if( args.Count != 3 ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Invalid number of argument for InstanceOf" );
			}
			YaccaiVal v1 = (YaccaiVal)args[1];
			YaccaiVal v2 = (YaccaiVal)args[2];
			
			if( !InstanceOfClass( v2, "class", env ) ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "ClassName required for argument 2 of InstanceOf" );
			}
			string strName = ( (YClass)( v2.m_contents ) ).m_strName;
			if( InstanceOfClass( v1, strName, env ) ) {
				return new YaccaiVal( YaccaiType.INT, 1 );
			}
			return new YaccaiVal( YaccaiType.INT, 0 );
		}

		public YaccaiVal NtEvalExpr( ArrayList args, YEnv env )
		{
			if( args.Count != 2 ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Invalid number of argument for EvalExpr" );
			}
			YaccaiVal v1 = (YaccaiVal)args[1];
			if( v1.m_type != YaccaiType.OBJECT ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Invalid argument type for EvalExpr" );
			}
			YObject v1Obj = (YObject)v1.m_contents;
			string strExpr = (string)v1Obj.GetMemberEx( "2contents", env );
			YaccaiLexer lex = new YaccaiLexer( new Antlr.Runtime.ANTLRStringStream( strExpr ) );
			CommonTokenStream tks = new CommonTokenStream( lex );
			YaccaiParser yParser = new YaccaiParser( tks );
			yParser.StrInputFileName = "NativeFuncs.cs";

			Expr yExp = null;
			try {
				yExp = yParser.yaccai_expr();
			} catch( Exception ex ) {
				Console.WriteLine( ex.Message );
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Parse error for input expression" );
			}
			if( yParser.IsSuccessParse() ) {
				YaccaiVal retVal = EvalExpr( yExp, env );
				return retVal;
			}
			return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Error while evaluating embedded expression" );
		}
		public YaccaiVal NtGetRank( ArrayList args, YEnv env )
		{
			return new YaccaiVal( YaccaiType.INT, m_nMyProcId );
		}
		public YaccaiVal Nt_Peer_Peer( ArrayList args, YEnv env )
		{
			YaccaiVal v0, v1, v2;
			v0 = (YaccaiVal)args[0];
			v1 = (YaccaiVal)args[1];
			v2 = (YaccaiVal)args[2];
			if( v1.m_type != YaccaiType.OBJECT || v2.m_type != YaccaiType.INT ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, "Invalid type for Peer" );
			}
			int nPort = (int)v2.m_contents;
			YObject v1Obj = (YObject)v1.m_contents;
			YObject v0Obj = (YObject)v0.m_contents;
			string strHost = (string)v1Obj.GetMemberEx( "2contents", env );
			try {
				Socket sk = new Socket( AddressFamily.InterNetwork, SocketType.Stream,
										ProtocolType.Tcp );
				IPHostEntry ipHostEntry = Dns.GetHostEntry( strHost );
				if( ipHostEntry != null ) {
					IPAddress ipAddr = ipHostEntry.AddressList[0];
					sk.Connect( new IPEndPoint( ipAddr, nPort ) );
					v0Obj.m_instanceVars["2Sock"] = sk;
					v0Obj.m_instanceVars["LocalHost"] = NativeObjects.YStringObject( Dns.GetHostName() );
					v0Obj.m_instanceVars["LocalPort"] = new YaccaiVal( YaccaiType.INT, ( (IPEndPoint)sk.LocalEndPoint ).Port );
					v0Obj.m_instanceVars["Host"] = NativeObjects.YStringObject( strHost );
					v0Obj.m_instanceVars["Port"] = new YaccaiVal( YaccaiType.INT, nPort );
				}
			} catch( Exception ex ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, ex.Message );
			}
			return v0;
		}
		public YaccaiVal Nt_Peer_Send( ArrayList args, YEnv env )
		{
			YaccaiVal v0 = (YaccaiVal)args[0];
			YObject v0Obj = (YObject)v0.m_contents;
			Socket sk = (Socket)v0Obj.GetMemberEx( "2Sock", env );
			if( !sk.Connected ) Console.WriteLine( "disconnected" );
			try {
				NetworkStream ns = new NetworkStream( sk );
				StreamWriter sw = new StreamWriter( ns );
				YaccaiVal v1 = (YaccaiVal)args[1];
				string strToSend = (string)( (YObject)v1.m_contents ).GetMemberEx( "2contents", env );
				if( IsYaccaiMainThread() && m_bMainThreadExecutionTurn ) {
					m_bMainThreadExecutionTurn = false;
					m_mutexExecutionTurn.ReleaseMutex();
				}
				//Console.WriteLine( "Agent{0}: PeerSend: wait for send", m_nMyProcId );
				sw.WriteLine( strToSend );
				sw.Flush();
				if( IsYaccaiMainThread() && !m_bMainThreadExecutionTurn ) {
					//Console.WriteLine( "Agent{0}: wait to complete PeerSend", m_nMyProcId );
					m_mutexExecutionTurn.WaitOne();
					//Console.WriteLine( "Agent{0}: ok, completed PeerSend", m_nMyProcId );
					m_bMainThreadExecutionTurn = true;
				}
				return new YaccaiVal( YaccaiType.INT, 1 );
			} catch( Exception ex ) {
				Console.WriteLine( ex.Message );
				return new YaccaiVal( YaccaiType.INT, 0 );
			}
		}
		public YaccaiVal Nt_Peer_Recv( ArrayList args, YEnv env )
		{
			YaccaiVal v0 = (YaccaiVal)args[0];
			YObject v0Obj = (YObject)v0.m_contents;
			Socket sk = (Socket)v0Obj.GetMemberEx( "2Sock", env );
			try {
				NetworkStream ns = new NetworkStream( sk );
				StreamReader sr = new StreamReader( ns );
				if( IsYaccaiMainThread() && m_bMainThreadExecutionTurn ) {
					m_bMainThreadExecutionTurn = false;
					m_mutexExecutionTurn.ReleaseMutex();
				}
				//Console.WriteLine( "Agent{0}: PeerRecv: wait data", m_nMyProcId );
				string strRecv = sr.ReadLine();
				if( IsYaccaiMainThread() && !m_bMainThreadExecutionTurn ) {
					//Console.WriteLine( "Agent{0}: wait to complete PeerRecv", m_nMyProcId );
					m_mutexExecutionTurn.WaitOne();
					//Console.WriteLine( "Agent{0}: ok, completed PeerRecv", m_nMyProcId );
					m_bMainThreadExecutionTurn = true;
				}

				return NativeObjects.YStringObject( strRecv );
			} catch( Exception ex ) {
				Console.WriteLine( ex.Message );
				return new YaccaiVal( YaccaiType.NULL, null );
			}

		}
		public YaccaiVal Nt_Peer_Close( ArrayList args, YEnv env )
		{
			YaccaiVal v0 = (YaccaiVal)args[0];
			YObject v0Obj = (YObject)v0.m_contents;
			Socket sk = (Socket)v0Obj.GetMemberEx( "2Sock", env );
			try {
				sk.Close();
				return new YaccaiVal( YaccaiType.VOID, null );
			} catch( Exception ex ) {
				return new YaccaiVal( YaccaiType.RUNTIME_ERROR, ex.Message );
			}
		}

		public YaccaiVal Nt_String_Equals( ArrayList args, YEnv env )
		{
			YaccaiVal v0 = (YaccaiVal)args[0];
			YaccaiVal v1 = (YaccaiVal)args[1];
			YObject v0Obj = (YObject)v0.m_contents;
			YObject v1Obj = (YObject)v1.m_contents;
			string str1 = (string)v0Obj.GetMemberEx( "2contents", env );
			string str2 = (string)v1Obj.GetMemberEx( "2contents", env );
			if( str1.Equals( str2 ) ) {
				return new YaccaiVal( YaccaiType.INT, 1 );
			}
			return new YaccaiVal( YaccaiType.INT, 0 );
		}
		public YaccaiVal Nt_String_Split( ArrayList args, YEnv env )
		{
			YaccaiVal v0 = (YaccaiVal)args[0];
			YaccaiVal v1 = (YaccaiVal)args[1];
			YObject v0Obj = (YObject)v0.m_contents;
			YObject v1Obj = (YObject)v1.m_contents;
			string str1 = (string)v0Obj.GetMemberEx( "2contents", env );
			string str2 = (string)v1Obj.GetMemberEx( "2contents", env );
			string[] arrSplit = Regex.Split( str1, str2 );
			if( arrSplit == null ) return new YaccaiVal( YaccaiType.NULL, null );
			ExprObjectAllocation eoa = new ExprObjectAllocation( "Array", new LinkedList<Expr>(), new LinkedList<Expr>() );
			Expr eToEval = new Expr( eoa, new SrcPos( "NativeFuncs.cs", 0, 0 ) );
			YaccaiVal retVal = EvalExpr( eToEval, env );
			int i = 0;
			for( i = 0; i < arrSplit.Length; i++ ) {
				YaccaiVal v = NativeObjects.YStringObject( arrSplit[i] );
				ArrayList argLst = new ArrayList();
				argLst.Add( v );
				InvokeYaccaiMethod( retVal, "Add", argLst, env, new SrcPos( "NativeFuncs.cs", 0, 0 ) );
			}

			return retVal;
		}

		private void RegisterNativeObjects( YEnv env )
		{
			NativeObjects.m_yEvaluator = this;
			env.Bind( "Console", new YaccaiVal( YaccaiType.CSOBJ, new CSharpObject( typeof( Console ), null ) ) );
			env.Bind( "Math", new YaccaiVal( YaccaiType.CSOBJ, new CSharpObject( typeof( Math ), null ) ) );
			env.Bind( "Object", NativeObjects.YObjectClass() );
			env.Bind( "Array", NativeObjects.YArrayClass() );
			env.Bind( "String", NativeObjects.YStringClass() );
			env.Bind( "Environment", NativeObjects.YEnviromentClass() );
			env.Bind( "Communicator", NativeObjects.YCommunicatorClass() );
			env.Bind( "YMessage", NativeObjects.YMsgClass() );
			env.Bind( "Peer", NativeObjects.YPeerClass() );
			env.Bind( "InstanceOf", new YaccaiVal( YaccaiType.IDELEGATE, new YaccaiDelegate( this.NtInstanceOf ), YaccaiAccessType.Public ) );
			env.Bind( "Random", new YaccaiVal( YaccaiType.CSOBJ, new CSharpObject( typeof( Random ), new Random() ) ) );
		}
	}
}
