using System;
using System.Collections;
using System.Diagnostics;
using System.IO;
namespace Yaccai
{
	enum LookupSubDirType { BIN_DIR, CUR_DIR };
	class FileLookup
	{
		public ArrayList m_arrSearchDirs;
		public string m_strBinDir;
		public string m_strCurDir;
		private static char[] m_arrTrimChars = { Path.DirectorySeparatorChar };
		public FileLookup()
		{
			m_strBinDir = Path.GetFullPath( System.Reflection.Assembly.GetExecutingAssembly().Location );
			m_strBinDir = Path.GetDirectoryName( m_strBinDir );
			m_strBinDir.Trim( m_arrTrimChars );
			m_strCurDir = Environment.CurrentDirectory;
			m_strCurDir.Trim( m_arrTrimChars );
			m_arrSearchDirs = new ArrayList();
			m_arrSearchDirs.Clear();
			m_arrSearchDirs.Add( m_strCurDir );
			m_arrSearchDirs.Add( m_strBinDir );
			AddLookupSubDir( "preload", LookupSubDirType.BIN_DIR );
			
		}
		public void AddLookupDir( string strDir )
		{
			m_arrSearchDirs.Insert( 0, strDir );
		}
		public void AddLookupSubDir( string strSubDir, LookupSubDirType t )
		{
			string strPostfix = strSubDir;
			strPostfix.Trim( m_arrTrimChars );
			string strDir = "";
			switch( t ) {
				case LookupSubDirType.BIN_DIR:
					strDir = m_strBinDir + Path.DirectorySeparatorChar + strPostfix;
					break;
				case LookupSubDirType.CUR_DIR:
					strDir = m_strCurDir + Path.DirectorySeparatorChar + strPostfix;
					break;
				default:
					break;
			}
			m_arrSearchDirs.Add( strDir );
		}
		
		public string LookupFile( string strFileName )
		{
			if( File.Exists( strFileName ) ) {
				return strFileName;
			} else {
				if( strFileName.StartsWith( "/" ) ) {	// not found
					return null;
				} else {	// lookup in other directories
					string strToSearch = "";
					foreach( string strPrefix in m_arrSearchDirs ) {
						strToSearch = strPrefix + Path.DirectorySeparatorChar + strFileName;
						if( File.Exists( strToSearch ) ) return strToSearch;
					}
					return null;
				}
			}
		}
	}
}
