grammar Yaccai;
options {
	language = CSharp;
	backtrack = true;
	
}

@parser::header {

using StmtList = LinkedList<Stmt>;
}

@lexer::namespace {
	Yaccai
}

@parser::namespace {
	Yaccai
}

@parser::members {
private String m_strFileName;
private bool m_bYaccaiSuccessParse = true;
public String StrInputFileName {
	get {
		return m_strFileName;
	}
	set {
		m_strFileName = value;
	}
}
public bool IsSuccessParse()
{
	return (m_bYaccaiSuccessParse && !failed);
}
private SrcPos MakeSrcPos( IToken t ) {
	return new SrcPos( m_strFileName, t.Line, t.CharPositionInLine );
}
public override void ReportError( RecognitionException rEx )
{
	base.ReportError( rEx );
	m_bYaccaiSuccessParse = false;
}
}
@lexer::members{
private String m_strFileName;
public String StrInputFileName {
	get {
		return m_strFileName;
	}
	set {
		m_strFileName = value;
	}
}
private SrcPos MakeSrcPos( IToken t ) {
	return new SrcPos( m_strFileName, t.Line, t.CharPositionInLine );
}	
}

//INT_LITERAL | DOUBLE_LITERAL | CHAR_LITERAL | STRING_LITERAL;

object_allocation returns [Expr value] 
@init{
	LinkedList<Expr> expr_lst = new LinkedList<Expr>();
	LinkedList<string> name_lst = new LinkedList<string>();
	LinkedList<Expr> bodyLst = null;
	expr_lst.Clear();
	name_lst.Clear();
	ExprObjectAllocation oa = null;
}	:
	(( tknew = TOK_KW_NEW )
		(	(
				(t = IDENTIFIER LPAREN expLst = expr_list RPAREN)  
				(LBRACE (body_exprLst = expr_list){bodyLst = $body_exprLst.value;} RBRACE)?
			) { oa =  new ExprObjectAllocation( $t.text, $expLst.value, bodyLst ); }
		|	( LBRACE
				( |
				 ((t1 = IDENTIFIER TOK_EQ eee1 = expression){ expr_lst.AddLast( $eee1.value ); name_lst.AddLast( $t1.text );})
				 ((TOK_COMMA t2=IDENTIFIER TOK_EQ eee2 = expression){expr_lst.AddLast( $eee2.value ); name_lst.AddLast( $t2.text ); })*   
				)  
			  RBRACE ) { oa = new ExprObjectAllocation( name_lst, expr_lst ); }
		)
	) {$value = new Expr( oa, MakeSrcPos($tknew) );}	
	;

agent_allocation returns [Expr value]
@init{
	Expr hostnameExpr = null;
}
	:
		(
		TOK_KW_CREATE
		idf = IDENTIFIER
		LPAREN
			exprLst = expr_list
		RPAREN
		(TOK_KW_AT hostExpr = expression {hostnameExpr = $hostExpr.value;})?
		) { $value = new Expr( new ExprCreate( $idf.text, $exprLst.value, hostnameExpr ), MakeSrcPos( $TOK_KW_CREATE ) ); }
	;

expr_list returns [LinkedList<Expr> value]
@init{
	LinkedList<Expr> retLst = new LinkedList<Expr>();
	retLst.Clear();
}:
		// empty
		{$value = retLst;}
	|
		eee1 = expression {retLst.AddLast($eee1.value); $value = retLst;}
		(TOK_COMMA (eee = expression { retLst.AddLast( $eee.value ); $value = retLst;} )
		)*
	;

regex_expr_list returns [LinkedList<Expr> value]
@init {
	LinkedList<Expr> retLst = new LinkedList<Expr>();
	retLst.Clear();
	string strOpType = "";
}:
		(opType1=('*'){strOpType="*";})
		{
			retLst.Add( new Expr( new ExprRegexExpr( strOpType, null ), MakeSrcPos( $opType1 ) ) );
		}
		{$value = retLst;}
	|	
		((eee1 = expression) (opType=('*' | '+' | '?' ){strOpType=$opType.Text;})?)
		{
			ExprRegexExpr regexExp = new ExprRegexExpr( strOpType, $eee1.value );
			retLst.Add( new Expr( regexExp, $eee1.value.Pos ) );
		}
		(
			TOK_COMMA { strOpType = "";}
			((eee2 = expression) (opType2=('*' | '+' | '?'){strOpType=$opType2.Text;})?)
			{
				ExprRegexExpr regexExp2 = new ExprRegexExpr( strOpType, $eee2.value );
				retLst.Add( new Expr( regexExp2, $eee2.value.Pos ) );
			}
		)*
		{
			$value = retLst;
		}
	;
class_signature returns [YaccaiClassSignature value]
@init
{
	LinkedList<string> memberList = null;
}
	:
		(t = IDENTIFIER {$value = new YaccaiClassSignature($t.text);})
	|	( LBRACE { memberList = new LinkedList<string>(); memberList.Clear();}
			( | 
			    (t1 = IDENTIFIER {memberList.AddLast( $t1.text );}
			     (TOK_COMMA t2 = IDENTIFIER {memberList.AddLast( $t2.text );})* )	 
			)
		  RBRACE) {$value = new YaccaiClassSignature( memberList );}
	;
belief_projection returns [BeliefProjection value]
@init{
	LinkedList<string> memberLst = null;
	string strClassName = null;
}
	:
		(t = IDENTIFIER {strClassName = $t.text;}
		( | (LBRACE {memberLst = new LinkedList<string>();}
		 	(  | (t1 = IDENTIFIER { memberLst.AddLast( $t1.text );}
		 		(TOK_COMMA t2 = IDENTIFIER {memberLst.AddLast( $t2.text );})*))
		    RBRACE ))) {$value = new BeliefProjection( strClassName, memberLst );}
	;
belief_add_expr returns [ExprBelief value]
	:
		TOK_KW_FACT eee = expression {$value = new ExprBelief( $eee.value );}
	;
belief_remove_expr returns [ExprBelief value]
@init
{
	BeliefProjection p = null;
	Expr f = null;
	YaccaiClassSignature ycs = null;
}
	:
		(TOK_KW_REMOVE
		(cst = class_signature { ycs = $cst.value; })
		( TOK_KW_AS 
		  (bpro = belief_projection {p = $bpro.value;})
		  (TOK_KW_WHERE (eee = expression {f = $eee.value;}))?
		)?) {$value = new ExprBelief( BeliefExprType.Remove, ycs, p, f);}
	;
belief_query_expr returns [ExprBelief value]
@init
{
	BeliefProjection p = null;
	Expr f = null;
	YaccaiClassSignature ycs = null;
}
	:
		(TOK_KW_QUERY
		(cst = class_signature { ycs = $cst.value; })
		( TOK_KW_AS 
		  (bpro = belief_projection {p = $bpro.value;})
		  (TOK_KW_WHERE (eee = expression {f = $eee.value;}))?
		)?) {$value = new ExprBelief( BeliefExprType.Query, ycs, p, f);}
	;
/*
belief_join_expr returns [ExprBelief value]
@init
{
	BeliefProjection p = null;
	Expr bfilter = null;
}
	:
		((be1 = belief_expr)
		TOK_KW_JOIN
		(be2 = belief_expr)
		TOK_KW_ON
		(eee1 = expression)
		(TOK_KW_AS
		 (bpr = belief_projection {p = $bpr.value;})
		 (TOK_KW_WHERE eee2 = expression{bfilter = $eee2.value;})? 
		)?) {$value = new ExprBelief( $be1.value, $be2.value, p, bfilter );}
	;
*/
belief_expr returns [Expr value]
@init{
	ExprBelief bexp = null;
	BeliefProjection p = null;
	Expr bfilter = null;
}
	:
		(((tokBl = TOK_KW_BELIEF)
			(	(eee = belief_query_expr) {bexp = $eee.value; }
			|	(eee1 = belief_remove_expr) {bexp = $eee1.value; }
			|	(eee3 = belief_add_expr) {bexp = $eee3.value;}
			)
		) {$value = new Expr( bexp, MakeSrcPos( $tokBl ) );})
		(
		(
		tkj = TOK_KW_JOIN
		be2 = belief_expr
		TOK_KW_ON
		(eee4 = expression)
		(TOK_KW_AS
			(bpr = belief_projection { p = $bpr.value; })
			(TOK_KW_WHERE eee5 = expression {bfilter = $eee5.value;})?
		)?
		) {$value = new Expr( new ExprBelief( $value, $be2.value, p, bfilter ), MakeSrcPos( $tkj ) ); }
		)*
	;
atom returns [Expr value]	:	lt = literal {$value = $lt.value; } 
				| 	IDENTIFIER { $value = new Expr( ExprType.Var, $IDENTIFIER.text, MakeSrcPos( $IDENTIFIER ) );} 
				| 	LPAREN eee = expression { $value = new Expr( ExprType.Expression, $eee.value, MakeSrcPos( $LPAREN ) ); } RPAREN 
				;

primary returns [Expr value]	:	a = atom {$value = $a.value;}
					   (t = trailer{switch( $t.value.m_type ) {
					   			case TrailerType.AttributeRef:
					   				$value = new Expr( new ExprAttref( $value, (Expr)$t.value.m_contents ), $t.value.m_pos );
					   				break;
					   			case TrailerType.Call:
					   				$value = new Expr( new ExprFuncCall( $value, (ArrayList)$t.value.m_contents ), $t.value.m_pos ); 
					   				break;
					   			case TrailerType.Subscript:
					   				$value = new Expr( new ExprSubscript( $value, (Expr)$t.value.m_contents ), $t.value.m_pos );
					   				break;
					   		} 
					   		}
					   )*;

trailer	returns [ExprTrailer value] 	:
			LPAREN {$value = new ExprTrailer( TrailerType.Call, new ArrayList(), MakeSrcPos($LPAREN) ); } (el = expression_list{$value.m_contents = $el.value;})? RPAREN
		|	LBRACK e = expression{$value = new ExprTrailer( TrailerType.Subscript, $e.value, MakeSrcPos($LBRACK) );} RBRACK
		|	TOK_DOT IDENTIFIER {$value = new ExprTrailer( TrailerType.AttributeRef, new Expr( ExprType.Var, $IDENTIFIER.text, MakeSrcPos( $IDENTIFIER ) ), MakeSrcPos( $IDENTIFIER) );};


expression_list returns [ArrayList value]
	:	e1 = expression {$value = new ArrayList(); $value.Add($e1.value);}  
		(TOK_COMMA e2=expression{$value.Add($e2.value);})*;

//new_expr:	'Tao' class_name '(' expression_list? ')';
match_stmt returns [Stmt value]
@init{
	LinkedList<YaccaiMatchPair> matchList = new LinkedList<YaccaiMatchPair>();
	matchList.Clear();
}	:
	(
		tkm = TOK_KW_MATCH 
		eee1 = expression
		TOK_KW_WITH 
		LBRACE
		(expList1 = regex_expr_list TOK_KW_ARROW st1 = statement) 
		{ matchList.AddLast( new YaccaiMatchPair( $expList1.value, $st1.value) );}
		(
			(TOK_BITWISE_OR expList2 = regex_expr_list TOK_KW_ARROW st2 = statement)
			{matchList.AddLast( new YaccaiMatchPair( $expList2.value, $st2.value) );}
		)*
		RBRACE
	) { $value = new Stmt( new MatchStmt( $eee1.value, matchList ), MakeSrcPos( $tkm ) ) ; }
	;
stop_eval_expr returns [Expr value]
@init{
	SrcPos p = null;
}	:
	(
		(tka = TOK_KW_AT) {p = MakeSrcPos( $tka );}
		LBRACE
		eee1 = expression 
		RBRACE
	) { $value = new Expr( ExprType.StopEvalExpr, $eee1.value, p ); }
	;
u_expr	returns [Expr value]
@init{
	ArrayList args_lst = new ArrayList();
	args_lst.Clear();
}
	:	p1 = primary {$value = $p1.value;} 
	| 	TOK_MINUS u1 = u_expr {args_lst.Add( $u1.value ); $value = new Expr( new ExprOperator( OperatorFixKind.PreFix, OperatorType.UMINUS, args_lst ), MakeSrcPos( $TOK_MINUS ) );}   
	| 	TOK_PLUS u2 = u_expr {args_lst.Add( $u2.value ); $value = new Expr( new ExprOperator( OperatorFixKind.PreFix, OperatorType.UPLUS, args_lst ), MakeSrcPos( $TOK_PLUS ) );}
	|	TOK_OP_NOT  u3 = u_expr { args_lst.Add( $u3.value ); $value = new Expr( new ExprOperator( OperatorFixKind.PreFix, OperatorType.NOT, args_lst ), MakeSrcPos( $TOK_OP_NOT ) );}
	|	TOK_BITWISE_NOT u4 = u_expr { args_lst.Add( $u4.value ); $value = new Expr( new ExprOperator( OperatorFixKind.PreFix, OperatorType.BITWISE_NOT, args_lst ), MakeSrcPos( $TOK_BITWISE_NOT ));}
	|	oa = object_allocation { $value = $oa.value;}
	|	belief_e = belief_expr {$value = $belief_e.value;}
	|	agent_alloc = agent_allocation{$value = $agent_alloc.value;}
	|	stop_eval = stop_eval_expr {$value = $stop_eval.value;}
	;

m_expr	returns [Expr value]
@init{
	ArrayList args_lst;
	OperatorType opt = OperatorType.MUL;
	SrcPos src_pos = null;
}
	:	u1 = u_expr {$value = $u1.value;} 
		((ttt=TOK_MUL {opt = OperatorType.MUL;}|ttt=TOK_DIV{opt = OperatorType.DIV;}|ttt=TOK_MOD{opt = OperatorType.MOD;}) {src_pos = MakeSrcPos( $ttt );} 
		  u2 = u_expr {args_lst = new ArrayList(); args_lst.Add($value); args_lst.Add( $u2.value ); $value = new Expr( new ExprOperator( OperatorFixKind.InFix, opt, args_lst ), src_pos ); })*;

a_expr 	returns [Expr value]
@init{
	ArrayList args_lst;
	OperatorType opt = OperatorType.PLUS;
	SrcPos src_pos = null;
}
	:	e1 = m_expr {$value = $e1.value; }
		((ttt=TOK_PLUS{opt = OperatorType.PLUS;}|ttt=TOK_MINUS{opt = OperatorType.MINUS;}) {src_pos = MakeSrcPos( $ttt );} 
		 e2 = m_expr{args_lst = new ArrayList(); args_lst.Add($value); args_lst.Add($e2.value); $value = new Expr( new ExprOperator( OperatorFixKind.InFix, opt, args_lst ), src_pos ); })*;

s_expr returns [Expr value]
@init{
	ArrayList args_lst;
	OperatorType opt = OperatorType.PLUS;
	SrcPos src_pos = null;
}
	:
		e1 = a_expr {  $value = $e1.value; }
		(
		ttt = (TOK_GT_GT{opt = OperatorType.GT_GT;} | TOK_LT_LT {opt = OperatorType.LT_LT;})
		{src_pos = MakeSrcPos($ttt); }
		e2 = a_expr 
		{ 	args_lst = new ArrayList();
			args_lst.Clear();
			args_lst.Add( $value );
			args_lst.Add( $e2.value ); 
			$value = new Expr( new ExprOperator(OperatorFixKind.InFix, opt, args_lst), src_pos ); 
		}
		)*
	;
comparison returns [Expr value]
@init{
	ArrayList args_lst;
	OperatorType opt = OperatorType.GT;
}
	:	e1 = s_expr {$value = $e1.value;} 
		((op = comp_operator){opt = $op.value.m_type;} 
		 e2 = s_expr{args_lst = new ArrayList(); args_lst.Add($value); args_lst.Add($e2.value); $value = new Expr( new ExprOperator( OperatorFixKind.InFix, opt, args_lst ) , $e2.value.Pos ); })?;
	
comp_operator returns [OperatorTypeWrapper value]
@init{
	$value = null;
}
	:	TOK_GT{$value = new OperatorTypeWrapper( OperatorType.GT ); } 
	| 	TOK_LT{$value = new OperatorTypeWrapper( OperatorType.LT ); } 
	| 	TOK_EQ_EQ{$value = new OperatorTypeWrapper( OperatorType.EQ_EQ ); } 
	|	TOK_GT_EQ{$value = new OperatorTypeWrapper( OperatorType.GT_EQ ); }
	| 	TOK_LT_EQ{$value = new OperatorTypeWrapper( OperatorType.LT_EQ ); } 
	| 	TOK_DIFF{$value = new OperatorTypeWrapper( OperatorType.DIFF );};
/*	
not_test returns [Expr value]
@init{
	SrcPos src_pos;
	ArrayList args_lst;
}
	:	c = comparison{$value = $c.value; } 
	| 	TOK_OP_NOT {src_pos = MakeSrcPos( $TOK_KW_NOT );} 
		nt = not_test{args_lst = new ArrayList(); args_lst.Add( $nt.value ); $value = new Expr( new ExprOperator( OperatorFixKind.PreFix, OperatorType.NOT, args_lst ), src_pos );};
*/
ba_expr  returns [Expr value]
@init
{
	ArrayList args_lst;
	SrcPos src_pos = null;
}
	:
		c1 = comparison {$value = $c1.value; }
		(
		tba = TOK_BITWISE_AND {src_pos = MakeSrcPos($tba);}
		c2 = comparison
		{
			args_lst = new ArrayList();
			args_lst.Clear();
			args_lst.Add( $value );
			args_lst.Add( $c2.value );
			$value = new Expr( new ExprOperator( OperatorFixKind.InFix, OperatorType.BITWISE_AND, args_lst ), src_pos );
		} 
		)*
	;	
bx_expr returns [Expr value]
@init{
	ArrayList args_lst;
	SrcPos src_pos = null;
}	:
		ba1 = ba_expr {$value = $ba1.value;}
		(
		tbx = TOK_BITWISE_XOR {src_pos = MakeSrcPos($tbx);}
		ba2 = ba_expr
		{
			args_lst = new ArrayList();
			args_lst.Clear();
			args_lst.Add( $value );
			args_lst.Add( $ba2.value );
			$value = new Expr( new ExprOperator( OperatorFixKind.InFix, OperatorType.BITWISE_XOR, args_lst ), src_pos );
		}
		)*
	;
bo_expr returns [Expr value]
@init
{
	ArrayList args_lst;
	SrcPos src_pos = null;
}	:
		bx1 = bx_expr {$value = $bx1.value;}
		(
		tbo = TOK_BITWISE_OR { src_pos = MakeSrcPos($tbo); }
		bx2 = bx_expr
		{
			args_lst = new ArrayList();
			args_lst.Clear();
			args_lst.Add( $bx2.value );
			$value = new Expr( new ExprOperator( OperatorFixKind.InFix, OperatorType.BITWISE_OR, args_lst ), src_pos );
		}
		)*
	;
and_test returns [Expr value]
@init{
	SrcPos src_pos = null;
	ArrayList args_lst;
}

	:	nt = bo_expr{$value = $nt.value;} 
		( TOK_OP_AND{src_pos = MakeSrcPos($TOK_OP_AND);} 
		  nt1 = bo_expr{args_lst = new ArrayList(); args_lst.Add( $value ); args_lst.Add( $nt1.value );
		  		 $value = new Expr( new ExprOperator( OperatorFixKind.InFix, OperatorType.AND, args_lst ), src_pos );
		  		} )*;

or_test	returns [Expr value]	
@init{
	SrcPos src_pos = null;
	ArrayList args_lst;
}
	:	at = and_test{$value = $at.value;} 
		( TOK_OP_OR{src_pos = MakeSrcPos($TOK_OP_OR);} 
		  at1 = and_test{
		  		 args_lst = new ArrayList();
		  		 args_lst.Add( $value );
		  		 args_lst.Add( $at1.value );
		  		 $value = new Expr( new ExprOperator( OperatorFixKind.InFix, OperatorType.OR, args_lst ), src_pos );
		  		} )*;

assignment_expression returns [Expr value]
@init
{
	LinkedList<Expr> primaryList = new LinkedList<Expr>();
	LinkedList<OperatorType> opTypeList = new LinkedList<OperatorType>();
	primaryList.Clear();
	opTypeList.Clear();
	SrcPos src_pos = null;
}
	:	(	
			(
				(pr = primary {primaryList.AddFirst(pr);}
				(
					TOK_EQ { opTypeList.AddFirst( OperatorType.EQ ); src_pos = MakeSrcPos( $TOK_EQ ); }
				|	TOK_PLUS_EQ { opTypeList.AddFirst( OperatorType.PLUS_EQ ); src_pos = MakeSrcPos( $TOK_PLUS_EQ ); }
				|	TOK_MINUS_EQ { opTypeList.AddFirst( OperatorType.MINUS_EQ ); src_pos = MakeSrcPos( $TOK_MINUS_EQ ); }
				|	TOK_MUL_EQ { opTypeList.AddFirst( OperatorType.MUL_EQ ); src_pos = MakeSrcPos( $TOK_MUL_EQ );}
				|	TOK_DIV_EQ { opTypeList.AddFirst( OperatorType.DIV_EQ ); src_pos = MakeSrcPos( $TOK_DIV_EQ );}
				|	TOK_MOD_EQ { opTypeList.AddFirst( OperatorType.MOD_EQ ); src_pos = MakeSrcPos( $TOK_MOD_EQ );}
				|	TOK_LT_LT_EQ { opTypeList.AddFirst( OperatorType.LT_LT_EQ ); src_pos = MakeSrcPos( $TOK_LT_LT_EQ );}
				|	TOK_GT_GT_EQ { opTypeList.AddFirst( OperatorType.GT_GT_EQ ); src_pos = MakeSrcPos( $TOK_GT_GT_EQ );}
				|	TOK_BITWISE_OR_EQ { opTypeList.AddFirst( OperatorType.BITWISE_OR_EQ ); src_pos = MakeSrcPos( $TOK_BITWISE_OR_EQ );}
				|	TOK_BITWISE_AND_EQ { opTypeList.AddFirst( OperatorType.BITWISE_AND_EQ ); src_pos = MakeSrcPos( $TOK_BITWISE_AND_EQ );}
				|	TOK_BITWISE_XOR_EQ { opTypeList.AddFirst( OperatorType.BITWISE_XOR_EQ ); src_pos = MakeSrcPos( $TOK_BITWISE_XOR_EQ );}
					
				))+
			)
			eee_or = or_test {$value = new Expr( new ExprAssignment( primaryList, opTypeList, $eee_or.value ), src_pos );}
		|
			eee1_or = or_test
			{ $value = $eee1_or.value; }	
		)		
	;	
expression returns [Expr value]
	:	asmtexp = assignment_expression {$value = $asmtexp.value; }
	;


// statements /////////////

statement returns [Stmt value]
	:
	(				
		stm = expression_stmt 
	|	stm = if_stmt 
	|	stm = while_stmt
	|	stm = for_stmt
	|	stm = do_while_stmt
	|	stm = foreach_stmt
	|	stm = continue_stmt
	|	stm = return_stmt
	|	stm = break_stmt
	|	stm = label_decl_stmt
	|	stm = switch_stmt
	|	stm = stmt_block
	|	stm = plan_par_stmt
	|	stm = plan_and_stmt
	|	stm = plan_or_stmt
	|	stm = match_stmt 
	) {$value = $stm.value;}	
	;
expression_stmt returns [Stmt value]
	:
		TOK_SEMICOLON {$value = new Stmt( MakeSrcPos($TOK_SEMICOLON) );}
	|	eee = expression {$value = new Stmt( $eee.value );}
		TOK_SEMICOLON
	;
if_stmt	returns [Stmt value]
@init
{
	Stmt trueBr = null;
	Stmt falseBr = null;
	Expr ifCond = null;
	SrcPos p = null;
}
	:	
		(TOK_KW_IF{p = MakeSrcPos($TOK_KW_IF);} LPAREN eee = expression{ifCond = $eee.value;} RPAREN
		t_branch = statement{trueBr = $t_branch.value;}
		(TOK_KW_ELSE f_branch = statement {falseBr = $f_branch.value;})?)
		{$value = new Stmt( new IfStmt( ifCond, trueBr, falseBr ), p);}
	;
label_decl_stmt returns [Stmt value]
@init{
	LabelDeclStmt lds = null;
	SrcPos p = null;
}
	:
		(
			(TOK_KW_CASE{p = MakeSrcPos($TOK_KW_CASE);} eee = expression{lds = new LabelDeclStmt($eee.value);})
		|	(TOK_KW_DEFAULT {p = MakeSrcPos($TOK_KW_DEFAULT); lds = new LabelDeclStmt();})
		)
		TOK_COLON {$value = new Stmt( lds, p );}
	;
switch_stmt returns [Stmt value]
@init{
	Expr switchCond = null;
	LinkedList<Stmt> stmtLst = new LinkedList<Stmt>();
	stmtLst.Clear();
	SrcPos p = null;
}
	:
		(TOK_KW_SWITCH{ p = MakeSrcPos($TOK_KW_SWITCH); } LPAREN eee=expression{switchCond = $eee.value;} RPAREN
		LBRACE
			(
				lds = label_decl_stmt {stmtLst.AddLast($lds.value);}
			|	stm = statement {stmtLst.AddLast($stm.value);}
			)*
		RBRACE) {$value = new Stmt( new SwitchStmt( switchCond, stmtLst ), p );}
	;

while_stmt returns [Stmt value]
@init
{
	SrcPos p = null;
	Expr while_exp = null;
	Stmt st = null;
}
	:
		(
		TOK_KW_WHILE {p = MakeSrcPos($TOK_KW_WHILE);}
		LPAREN
		eee = expression{ while_exp = $eee.value; }
		RPAREN
		stm = statement{ st = $stm.value; }
		) {$value = new Stmt( new WhileStmt( while_exp, st ), p ); }
	;

do_while_stmt returns [Stmt value]
@init
{
	SrcPos p = null;
	Stmt s = null;
	Expr condEx = null;
}
	:	(
		TOK_KW_DO {p = MakeSrcPos( $TOK_KW_DO ); } stm = statement { s = $stm.value; }
		TOK_KW_WHILE LPAREN eee = expression { condEx = $eee.value; } RPAREN
		TOK_SEMICOLON
		) { $value = new Stmt( new DoWhileStmt( condEx, s ), p ); }
	;

for_stmt returns [Stmt value]
@init
{
	SrcPos p = null;	
}
	:
		(
		TOK_KW_FOR {p = MakeSrcPos( $TOK_KW_FOR ); }LPAREN
		expLst1 = expr_list
		TOK_SEMICOLON
		expLst2 = expr_list
		TOK_SEMICOLON
		expLst3 = expr_list
		RPAREN stm = statement
		) { $value = new Stmt( new ForStmt( $expLst1.value, $expLst2.value, $expLst3.value, $stm.value ), p ); }
	;

foreach_stmt returns [Stmt value]
@init
{
	SrcPos p = null;
}
	:
		(
		TOK_KW_FOREACH { p = MakeSrcPos( $TOK_KW_FOREACH );}
		LPAREN
		idf = IDENTIFIER
		TOK_KW_IN
		col_E = expression
		RPAREN
		stm = statement
		) { $value = new Stmt( new ForEachStmt( $idf.text, $col_E.value, $stm.value ), p ); }
	;
continue_stmt returns [Stmt value]
	:
		TOK_KW_CONTINUE
		{$value = new Stmt( StmtKind.Continue, MakeSrcPos($TOK_KW_CONTINUE) );}
		TOK_SEMICOLON
	;
break_stmt returns [Stmt value]
	:
		TOK_KW_BREAK
		{$value = new Stmt( StmtKind.Break, MakeSrcPos($TOK_KW_BREAK) );}
		TOK_SEMICOLON
	;
return_stmt returns [Stmt value]
@init{
	Stmt retVal = new Stmt( StmtKind.Return, new SrcPos( "", -1, -1 ), null );
}
	:	(TOK_KW_RETURN{retVal.Pos = MakeSrcPos( $TOK_KW_RETURN );} ((e = expression){retVal.Contents=$e.value;})?)
		{$value = retVal;}
		TOK_SEMICOLON
	;

stmt_block returns [Stmt value]
@init
{
	LinkedList<Stmt> retLst = new LinkedList<Stmt>();
	retLst.Clear();
}
	:
		(	LBRACE
			(stm = statement{ retLst.AddLast( $stm.value ); })*
			RBRACE
		)
		{ $value = new Stmt( retLst, MakeSrcPos($LBRACE) ); }
	;

plan_par_stmt returns [Stmt value]
	:
		(tkp = TOK_KW_PAR LPAREN 
		eeLst = expr_list 
		RPAREN TOK_SEMICOLON)
		{$value = new Stmt( StmtKind.PlanPar, $eeLst.value, MakeSrcPos( $tkp ) ); } 
	;
plan_or_stmt returns [Stmt value]
	:
		(tko = TOK_KW_OR LPAREN 
		eeLst = expr_list 
		RPAREN TOK_SEMICOLON)
		{$value = new Stmt( StmtKind.PlanOr, $eeLst.value, MakeSrcPos( $tko ) ); } 
	;
plan_and_stmt returns [Stmt value]
	:
		(tka = TOK_KW_AND LPAREN 
		eeLst = expr_list 
		RPAREN TOK_SEMICOLON)
		{$value = new Stmt( StmtKind.PlanAnd, $eeLst.value, MakeSrcPos( $tka ) ); } 
	;
parameter_list returns [ArrayList value]	
@init{
	ArrayList retLst = new ArrayList();
	retLst.Clear();
}
	:
	(
		// empty
	|	idf = IDENTIFIER { retLst.Add( $idf.text );}
		(TOK_COMMA idf1 = IDENTIFIER{ retLst.Add( $idf1.text ); })*
	) { $value = retLst; }
	;


method_decl_stmt returns [Stmt value]
@init{
	//ArrayList paramList = new ArrayList();
	LinkedList<Stmt> stmList = new LinkedList<Stmt>();
	//paramList.Clear();
	stmList.Clear();
	YaccaiAccessTypeWrapper yacct = new YaccaiAccessTypeWrapper( YaccaiAccessType.Public );
	bool bStatic = false;
}
	:
	(
		(acct = access_type{yacct = $acct.value;})?
		(TOK_KW_STATIC {bStatic = true;})?
		tkm = TOK_KW_FUNCTION
		idf = IDENTIFIER
		LPAREN
		prl = parameter_list
		RPAREN
		LBRACE
			(stm = statement{ stmList.AddLast($stm.value); })*
		RBRACE
	) {$value = new Stmt( new MethodDeclStmt( $idf.text, $prl.value, stmList, yacct.m_accessType, bStatic ), MakeSrcPos( $tkm ) ); }
	;

class_decl_stmt returns [Stmt value]
@init{
	LinkedList<Stmt> stmtList = new LinkedList<Stmt>();
	ArrayList parentList = new ArrayList();
	parentList.Clear();
	stmtList.Clear();
	YaccaiAccessTypeWrapper yacct = new YaccaiAccessTypeWrapper( YaccaiAccessType.Public );
}
	:
	(
		(acct = access_type{yacct = $acct.value;})?
		tkc = TOK_KW_CLASS
		idf = IDENTIFIER
		(TOK_KW_EXTENDS LBRACE parentLst = parameter_list{parentList = $parentLst.value;} RBRACE)?
		LBRACE
			( stm = method_decl_stmt{ stmtList.AddLast( $stm.value ); } 
			| stm1 = member_var_decl_stmt { stmtList.AddLast( $stm1.value ); }
			// this is for test
			| stm2 = plan_decl_stmt { stmtList.AddLast( $stm2.value ); }
			)*
		RBRACE
	) { $value = new Stmt( new ClassDeclStmt( $idf.text, parentList, stmtList, yacct.m_accessType ), MakeSrcPos( $tkc) ); }
	;

agent_class_decl_stmt returns [Stmt value]
@init{
	LinkedList<Stmt> stmtList = new LinkedList<Stmt>();
	ArrayList parentList = new ArrayList();
	parentList.Clear();
	stmtList.Clear();
	YaccaiAccessTypeWrapper yacct = new YaccaiAccessTypeWrapper( YaccaiAccessType.Public );
}
	:
	(
		(acct = access_type{yacct = $acct.value;})?
		tkc = TOK_KW_AGENTCLASS
		idf = IDENTIFIER
		(TOK_KW_EXTENDS LBRACE parentLst = parameter_list{parentList = $parentLst.value;} RBRACE)?
		LBRACE
			(stm = plan_decl_stmt { stmtList.AddLast( $stm.value ); }
			| stm = method_decl_stmt { stmtList.AddLast( $stm.value ); }
			| stm = member_var_decl_stmt { stmtList.AddLast( $stm.value ); })*
		RBRACE
	) { $value = new Stmt( new AgentClassDeclStmt( $idf.text, parentList, stmtList, yacct.m_accessType ), MakeSrcPos( $tkc) ); }
	;
	
plan_decl_stmt returns [Stmt value]
@init
{
	YaccaiAccessTypeWrapper yacct = new YaccaiAccessTypeWrapper( YaccaiAccessType.Public );
	Expr precondExp = null;
	Expr maintainExp = null;
	LinkedList<Stmt> stmList = new LinkedList<Stmt>();
	stmList.Clear();
}
	:
	(
		(acct = access_type {yacct = $acct.value;})?
		tkp = TOK_KW_PLAN
		idf = IDENTIFIER
		LPAREN
			paramLst = parameter_list	
		RPAREN
		(TOK_KW_PRECOND LPAREN eee1 = expression{ precondExp = $eee1.value; } RPAREN)?
		(TOK_KW_MAINTAINS LPAREN eee2 = expression {maintainExp = $eee2.value;} RPAREN)?
		LBRACE
			(stm = statement {stmList.AddLast($stm.value);})*
		RBRACE
	) {$value = new Stmt( new PlanDeclStmt( $idf.text, $paramLst.value, precondExp, maintainExp, stmList, yacct.m_accessType ), MakeSrcPos( $tkp ) );}
	;

member_var_decl_stmt returns [Stmt value]
@init
{
	YaccaiAccessTypeWrapper yacct = new YaccaiAccessTypeWrapper( YaccaiAccessType.Private );
	bool bStatic = false;
	LinkedList<MemberVarExprPair> mList = new LinkedList<MemberVarExprPair>();
	mList.Clear();
	MemberVarExprPair p = null;
}	:
	(
		(yac = access_type {yacct = $yac.value;})?
		(TOK_KW_STATIC{bStatic = true;})?
		idf = IDENTIFIER { p = new MemberVarExprPair( $idf.text, null ); mList.Add( p );}
		(TOK_EQ eee1 = expression{ p.m_expr = $eee1.value; })?
		(TOK_COMMA idf2 = IDENTIFIER { p = new MemberVarExprPair( $idf2.text, null ); mList.Add( p ); }
			(TOK_EQ eee2 = expression{ p.m_expr = $eee2.value; })?)*
		TOK_SEMICOLON
	) { $value = new Stmt( new MemberVarDeclStmt( mList, bStatic, yacct.m_accessType ), MakeSrcPos( $idf ) ); }
	;
include_stmt returns [Stmt value]
	:
		(TOK_KW_INCLUDE
		slt = string_literal TOK_SEMICOLON) { $value = new Stmt( StmtKind.Include, MakeSrcPos( $TOK_KW_INCLUDE ), $slt.value  ); }
	;
translation_unit returns [LinkedList<Stmt> value]
@init{
	LinkedList<Stmt> stmList = new LinkedList<Stmt>();
	stmList.Clear();
}
	:
	(
		(stm = include_stmt{ stmList.AddLast( $stm.value ); })*
		(stm1 = class_decl_stmt { stmList.AddLast( $stm1.value ); }| stm1 = agent_class_decl_stmt { stmList.AddLast( $stm1.value ); })*
	) {$value = stmList;}
	EOF
	;
	
yaccai_expr returns [Expr value] 
@init{
	
}
	:
		(yaccai_exp1 = expression{$value = $yaccai_exp1.value;})
		EOF
	;
///////////////////////////
access_type returns [YaccaiAccessTypeWrapper value]
	:
		TOK_KW_PUBLIC {$value = new YaccaiAccessTypeWrapper( YaccaiAccessType.Public );}
	|	TOK_KW_PRIVATE {$value = new YaccaiAccessTypeWrapper( YaccaiAccessType.Private );}
	|	TOK_KW_PROTECTED {$value = new YaccaiAccessTypeWrapper( YaccaiAccessType.Protected );}
	;
literal	returns [Expr value]
	:	(litr=int_literal | litr=double_literal | litr=string_literal | litr=char_literal) {$value = $litr.value;};

int_literal returns [Expr value]
	:	INT_LITERAL {$value = new Expr( int.Parse( $INT_LITERAL.text ), MakeSrcPos( $INT_LITERAL ) );};
	
double_literal returns [Expr value]
	:	DOUBLE_LITERAL {$value = new Expr( double.Parse( $DOUBLE_LITERAL.text ), MakeSrcPos( $DOUBLE_LITERAL ) );};
	
string_literal returns [Expr value]
	:	STRING_LITERAL{string strRet = $STRING_LITERAL.text; $value = new Expr( ExprType.LiteralString, strRet , MakeSrcPos( $STRING_LITERAL ) );};
	
char_literal returns [Expr value]
	:	CHAR_LITERAL{
				String strCharWithQuote = $CHAR_LITERAL.text;
				String strChar = strCharWithQuote.Remove( 0, 1 );
				strChar = strChar.Remove( 1, 1 );
				$value = new Expr( char.Parse( strChar ), MakeSrcPos( $CHAR_LITERAL ) );
			    };

LPAREN	:	'(';

RPAREN	:	')';

LBRACK	:	'[';

RBRACK	:	']';

LBRACE	:	'{';

RBRACE	:	'}';

TOK_PLUS:	'+';

TOK_MINUS
	:	'-';

TOK_MOD	:	'%';

TOK_MUL	:	'*';

TOK_DIV	:	'/';

TOK_EQ	:	'=';

TOK_EQ_EQ
	:	'==';

TOK_LT	:	'<';

TOK_GT	:	'>';

TOK_LT_EQ
	:	'<=';
	
TOK_GT_EQ
	:	'>=';
	
TOK_DIFF:	'!=';

TOK_DOT	:	'.';

TOK_OP_NOT
	:	'!';
	
TOK_OP_AND
	:	'&&';
	
TOK_OP_OR
	:	'||';
		
TOK_PLUS_EQ
	:	'+=';
TOK_MINUS_EQ
	:	'-=';
TOK_MUL_EQ
	:	'*=';
TOK_DIV_EQ
	:	'/=';
TOK_MOD_EQ
	:	'%=';
TOK_GT_GT
	:	'>>';
TOK_GT_GT_EQ
	:	'>>=';
TOK_LT_LT
	:	'<<';
TOK_LT_LT_EQ
	:	'<<=';
TOK_BITWISE_OR
	:	'|';
TOK_BITWISE_AND
	:	'&';
TOK_BITWISE_XOR
	:	'^';
TOK_BITWISE_NOT
	:	'~';
TOK_BITWISE_OR_EQ
	:	'|=';
TOK_BITWISE_AND_EQ
	:	'&=';
TOK_BITWISE_XOR_EQ
	:	'^=';

TOK_KW_RETURN
	:	'return';
	
TOK_KW_BREAK
	:	'break';
	
TOK_KW_CONTINUE
	:	'continue';

TOK_KW_IF
	:	'if';
		
TOK_KW_ELSE
	:	'else';
	
TOK_KW_FOR
	:	'for';
	
TOK_KW_FOREACH
	:	'foreach';

TOK_KW_DO
	:	'do';
TOK_KW_WHILE
	:	'while';
	
TOK_KW_INCLUDE
	:	'include';
	
TOK_KW_FUNCTION
	:	'function';
	
TOK_KW_CLASS
	:	'class';

TOK_KW_AGENTCLASS
	:	'agentclass';
TOK_KW_EXTENDS
	:	'extends';
TOK_KW_NEW
	:	'new';
TOK_KW_CREATE 
	:	'create';
TOK_KW_FACT
	:	'fact';
TOK_KW_REMOVE 
	:	'remove';
TOK_KW_BELIEF
	:	'belief';
TOK_KW_AS
	:	'as';
TOK_KW_JOIN
	:	'join';
TOK_KW_ON
	:	'on';
TOK_KW_QUERY
	:	'query';
TOK_KW_WHERE
	:	'where';
TOK_KW_CASE
	:	'case';
TOK_KW_DEFAULT
	:	'default';
TOK_KW_SWITCH
	:	'switch';
TOK_KW_IN
	:	'in';	
TOK_KW_OR
	:	'or';
TOK_KW_AND
	:	'and';
TOK_KW_PAR
	:	'par';
TOK_KW_PUBLIC
	:	'public';
TOK_KW_PRIVATE
	:	'private';
TOK_KW_PROTECTED
	:	'protected';
TOK_KW_PLAN
	:	'plan';
TOK_KW_PRECOND
	:	'precond';
TOK_KW_MAINTAINS
	:	'maintains';
TOK_KW_STATIC
	:	'static';
TOK_KW_MATCH
	:	'match';
TOK_KW_WITH
	:	'with';
TOK_KW_ARROW
	:	'->';
TOK_KW_AT
	:	'@';
TOK_COMMA
	:	',';
	
TOK_SEMICOLON
	:	';';
TOK_COLON
	:	':';

IDENTIFIER
	:	LETTER (LETTER|DIGIT)*;

fragment
LETTER	:	'A'..'Z' | 'a'..'z' | '_';

fragment
DIGIT	:	'0' | NZ_DIGIT;

fragment
NZ_DIGIT:	'1'..'9';

CHAR_LITERAL
	:	'\'' (EscapeSequence | ~('\''|'\\')) '\'';
	
INT_LITERAL
	:	NZ_DIGIT DIGIT* | '0';

DOUBLE_LITERAL
	:	('0' | NZ_DIGIT DIGIT*) '.' DIGIT*;

fragment
EscapeSequence
	:	'\\' ('b'|'t'|'n'|'r'|'\''|'\\'|'\"');
	
STRING_LITERAL
	:	'"' ( EscapeSequence | ~('\\'|'"') )* '"';


	
WS  :  (' '|'\r'|'\t'|'\n'|'\u000C') { $channel = HIDDEN; }
    ;

COMMENT
    :   '/*' ( options {greedy=false;} : . )* '*/' {$channel = HIDDEN;}
    ;

LINE_COMMENT
    : '//' ~('\n'|'\r')* '\r'? '\n' {$channel = HIDDEN; }
    ;
